package com.jeeplus.modules.sg.balancedlibrary.liKuResourcePool.utils;

import com.jeeplus.modules.sg.balancedlibrary.materialReportDetails.entity.MaterialReportDetails;
import com.jeeplus.modules.sys.utils.DictUtils;

import java.math.BigDecimal;
import java.util.*;

public class OptimalUtil {
    //是否有“元素组合的和”与“待比对值”相同的情况，true为有
    private boolean getEqual = false;
    //所有可能的元素组合列表
    private List<List<MaterialReportDetails>> result = new ArrayList<>();
    //最大浪费量
    private BigDecimal maxiNun = BigDecimal.valueOf(0.0);

    /**
     *
     * @param total 待比对的值
     * @param elements  所有元素集合
     * @return
     */
    public List<MaterialReportDetails> getOptimal(double total, List<MaterialReportDetails> elements){
        //list降序排列
        Collections.sort(elements, Comparator.comparing(MaterialReportDetails::getTotal));
        Collections.reverse(elements);
        solve(0,0,new ArrayList<>(),total,elements);

        //找到差值最小组合返回
        List<MaterialReportDetails> returnList = new ArrayList<>();
        BigDecimal max = BigDecimal.valueOf(0.0);
        for (List<MaterialReportDetails> detailsList :
                result) {
            BigDecimal bigAll = BigDecimal.valueOf(0.0);
            for (MaterialReportDetails details :
                    detailsList) {
                bigAll = bigAll.add(BigDecimal.valueOf(details.getTotal()));
            }
            if (bigAll.compareTo(max) > 0) {
                max = bigAll;
                returnList.clear();
                returnList.addAll(detailsList);
            }
        }

/*        for(List<MaterialReportDetails> bigList:result){
            String str = "";
            double listNum = 0;
            for(MaterialReportDetails i:bigList){
                listNum = listNum + i.getTotal();
                str = str + i + ",";
            }
            System.out.println(listNum+":"+str);
        }*/

        return returnList;
    }

    /**
     *
     * @param index 当前集合下标
     * @param sum   当前组合元素和
     * @param curr  当前组合元素集合
     * @param total 待比对的值
     * @param elements 所有元素集合
     */
    public void solve(int index, double sum, List<MaterialReportDetails> curr, double total, List<MaterialReportDetails> elements ){
        //如果找到元素组合的和与待比对值一样，则不往下继续查找
        String dictValue = DictUtils.getDictValue("maxWaste", "maximum_waste", "");
        maxiNun = new BigDecimal(dictValue);
        if(getEqual == true){
            return;
        }
        //走到这一步，所有最后一个元素也参考过（可能加入组合也可能不加入），最终还是组合值小于待比对值。则放入到result中
        if(index == elements.size()){
            BigDecimal allSum = BigDecimal.valueOf(sum);
            BigDecimal allTotal = BigDecimal.valueOf(total);
            BigDecimal subtract = allTotal.subtract(allSum).setScale(2, BigDecimal.ROUND_HALF_UP);
            if (subtract.compareTo(maxiNun) <= 0) {
                result.add(curr);
            }
            return;
        }
        MaterialReportDetails next = elements.get(index);
        index++;
        //如果将当前值加上已有元素组合的值等于待比对值，得到结果
        if((sum+next.getTotal())==total){
            curr.add(next);
            result = new ArrayList<>();
            result.add(curr);
            getEqual = true;
        //如果将当前值加上已有元素组合的值大于待比对值，则不考虑这种组合的后续可能性
        }else if((sum+next.getTotal()) > total){
            solve(index,sum,curr,total,elements);
        }else if((sum+next.getTotal()) < total){
            List newCurr = new ArrayList(curr);
            newCurr.add(next);
            solve(index,sum+next.getTotal(),newCurr,total,elements);
            solve(index,sum,curr,total,elements);
        }
    }
}
