package com.jeeplus.modules.sg.managementcenter.reserveManagement.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.sg.managementcenter.reserveManagement.entity.ReserveManagement;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 项目储备信息 Mapper
 * @author 徐滕
 * @version 2020-09-14
 */
@MyBatisMapper
public interface ReserveManagementMapper extends BaseMapper<ReserveManagement> {
    /**
     * 根据项目储备id查询项目信息
     * @param reserveManagement
     * @return
     */
    ReserveManagement queryByProjectReserveId(ReserveManagement reserveManagement);

    /**
     * 经理修改
     * @param reserveManagement
     */
    void updatejl(ReserveManagement reserveManagement);

    /**
     * 批量添加项目储备信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<ReserveManagement> list);

    /**
     * 导出数据查询
     * @param reserveManagement
     * @return
     */
    List<ReserveManagement> exportFindList(ReserveManagement reserveManagement);
}
